Unit AFG4C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAFSI_p;

procedure AFG4C(var A :Array of Complex; M :Integer; N :Integer;
                var NLEAD :Array of Integer; var RCOND :Real;
                var Z :Array of Complex; var IERR :Integer);

implementation

procedure AFG4C(var A :Array of Complex; M :Integer; N :Integer;
                var NLEAD :Array of Integer; var RCOND :Real;
                var Z :Array of Complex; var IERR :Integer);
var
I,J,JJ,K,KB,KP1,L,LL,NM1 :Integer;
ANORM,S,SM,X,YNORM :Real;
EK,T,WK,WKM :Complex;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300,_310,_320,_330,_340,_350,_360,_370,_380,_390,_400,_410,_420,_430,
_440,_450,_460,_470,_480,_490,_500,_510,_520,_530,_540,_550,_560,_570,
_580,_590,_600,_610,_620,_630,_640,_650,_660,_670,_680,_690,_700,_710,
_720,_730,_740,_750,_760;
{  -  FORTRAN }
function C1ABS(T: Complex): Real;
begin
Result := Abs(Creal(T)) + Abs(Aimag(T));
end;
{   - }
begin
{ ***************************************************C }
{   LU-PAOEHE METOOM AYCCA C BOPOM BEYEO  C }
{   EMEHTA O CTOY  OEHKA CA OYCOBEH-   C }
{   HOCT MATP A.                                 C }
{ ***************************************************C }
RCOND := 0.0;

{   YCTAHOBEHE KOHTPO HA BOMOHOCT EPEOHEH }
X := 0.0;
_10:

{   POBEPKA PABHOCT AAH APAMETPOB M  N }
if ( N >=  1 ) and (  M >=  1 ) 
 then goto _20;
IERR := 65;
UTAFSI('A','F','G','4','C',IERR);
goto _760;
_20:
IERR := 0;

{   BCEHE 1-HOPM MATP A }
ANORM := 0.0;
K := ((N) Mod (6));
KP1 := K + 1;
for J:=1 to N do
 begin
  S := 0.0;
  if ( K =  0 ) 
   then goto _40;
  for JJ:=1 to K do
   begin
    S := S + C1ABS(A[(JJ-1)+(J-1)*M]);
_30:
   end;
  if ( N <  6 ) 
   then goto _60;
_40:
  JJ := KP1;
  while ( JJ<=N ) do
   begin
    S := S + C1ABS(A[(JJ-1)+(J-1)*M]) + C1ABS(A[(JJ+0)+(J-1)*M]) +
    C1ABS(A[(JJ+1)+(J-1)*M]) + C1ABS(A[(JJ+2)+(J-1)*M]) +
    C1ABS(A[(JJ+3)+(J-1)*M]) + C1ABS(A[(JJ+4)+(J-1)*M]);
_50:
    inc(JJ,6);
   end;
_60:
  if ( S >  ANORM ) 
   then ANORM := S;
_70:
 end;

{   LU-PAOEHE MATP A }
NM1 := N - 1;
if ( NM1 <  1 ) 
 then goto _240;
for K:=1 to NM1 do
 begin
  KP1 := K + 1;

{   HAXOEHE HEKCA BEYEO EMEHTA L }
  L := K;
  S := C1ABS(A[(K-1)+(K-1)*M]);
  for J:=KP1 to N do
   begin
    if ( C1ABS(A[(J-1)+(K-1)*M]) <=  S ) 
     then goto _80;
    L := J;
    S := C1ABS(A[(J-1)+(K-1)*M]);
_80:
_90:
   end;
  NLEAD[K-1] := L;
  if ( Cabs(A[(L-1)+(K-1)*M]) =  0.0 ) 
   then goto _210;

{   EPECTAHOBKA,EC TPEYETC }
  if ( L =  K ) 
   then goto _100;
  T := A[(L-1)+(K-1)*M];
  A[(L-1)+(K-1)*M] := A[(K-1)+(K-1)*M];
  A[(K-1)+(K-1)*M] := T;
_100:

{   BCEHE MHOTEE }
  T := DivC(Cmplx(-1.0,0.0),A[(K-1)+(K-1)*M]);
  J := N - K;
  I := ((J) Mod (5)) + K;
  if ( I =  K ) 
   then goto _120;
  for J:=KP1 to I do
   begin
    A[(J-1)+(K-1)*M] := MulC(T,A[(J-1)+(K-1)*M]);
_110:
   end;
_120:
  I := I + 1;
  if ( I >  N ) 
   then goto _140;
  J := I;
  while ( J<=N ) do
   begin
    A[(J-1)+(K-1)*M] := MulC(T,A[(J-1)+(K-1)*M]);
    A[(J+0)+(K-1)*M] := MulC(T,A[(J+0)+(K-1)*M]);
    A[(J+1)+(K-1)*M] := MulC(T,A[(J+1)+(K-1)*M]);
    A[(J+2)+(K-1)*M] := MulC(T,A[(J+2)+(K-1)*M]);
    A[(J+3)+(K-1)*M] := MulC(T,A[(J+3)+(K-1)*M]);
_130:
    inc(J,5);
   end;
_140:

{   AYCCOBO CKEHE }
  for J:=KP1 to N do
   begin
    T := A[(L-1)+(J-1)*M];
    if ( L =  K ) 
     then goto _150;
    A[(L-1)+(J-1)*M] := A[(K-1)+(J-1)*M];
    A[(K-1)+(J-1)*M] := T;
_150:
    JJ := N - K;
    I := ((JJ) Mod (4)) + K;
    if ( I =  K ) 
     then goto _170;
    for JJ:=KP1 to I do
     begin
      A[(JJ-1)+(J-1)*M] := AddC(A[(JJ-1)+(J-1)*M],MulC(T,A[(JJ-1)+(K-1)*M]));
_160:
     end;
_170:
    I := I + 1;
    if ( I >  N ) 
     then goto _190;
    JJ := I;
    while ( JJ<=N ) do
     begin
      A[(JJ-1)+(J-1)*M] := AddC(A[(JJ-1)+(J-1)*M],MulC(T,A[(JJ-1)+(K-1)*M]));
      A[(JJ+0)+(J-1)*M] := AddC(A[(JJ+0)+(J-1)*M],MulC(T,A[(JJ+0)+(K-1)*M]));
      A[(JJ+1)+(J-1)*M] := AddC(A[(JJ+1)+(J-1)*M],MulC(T,A[(JJ+1)+(K-1)*M]));
      A[(JJ+2)+(J-1)*M] := AddC(A[(JJ+2)+(J-1)*M],MulC(T,A[(JJ+2)+(K-1)*M]));
_180:
      inc(JJ,4);
     end;
_190:
_200:
   end;
  goto _220;
_210:
  IERR := -K;
_220:
_230:
 end;
_240:
if ( Cabs(A[(N-1)+(N-1)*M]) =  0.0 ) 
 then IERR := -N;
NLEAD[N-1] := N;
if ( IERR =  0 ) 
 then goto _250;
UTAFSI('A','F','G','4','C',IERR);
goto _760;
_250:

{   BCEHE RCOND-BEH,OPATHO CY OYCOBEHHOCT MATP A. }
{    BCEH HOPM MATP INVERSE(A) PEAETC CCTEMA A*Z=Y, }
{   E Y-PEEHE CCTEM TRANS(A)*Y=E;KOMOHEHT BEKTOPA E BPATC }
{   TAKM OPAOM,TO MAKCMPOBAT HOPMY BEKTOPA W,E W-PEEHE }
{   CCTEM TRANS(U)*W=E. }

{   PEEHE CCTEM TRANS(U)*W=E OHOBPEMEHHO C BOPOM E }
EK := Cmplx(1.0,0.0);
if ( N >=  2 ) 
 then goto _260;
RCOND := 1.0;
goto _760;
_260:
for J:=1 to N do
 begin
  Z[J-1] := Cmplx(0.0,0.0);
_270:
 end;
for K:=1 to N do
 begin
  YNORM := C1ABS(EK);
  if ( C1ABS(Z[K-1]) <>  0.0 )
   then EK := MulC(SubC(Cmplx(0.0,0.0),Z[K-1]),Cmplx(YNORM/C1ABS(Z[K-1]),0.0));
  if ( C1ABS(SubC(EK,Z[K-1])) <=  C1ABS(A[(K-1)+(K-1)*M]) ) 
   then goto _340;
  S := C1ABS(A[(K-1)+(K-1)*M])/C1ABS(SubC(EK,Z[K-1]));
  LL := 330;
_280:
  I := ((N) Mod (5));
  T := Cmplx(S,0.0);
  if ( I =  0 ) 
   then goto _300;
  for JJ:=1 to I do
   begin
    Z[JJ-1] := MulC(T,Z[JJ-1]);
_290:
   end;
  if ( N <  5 ) 
   then goto _320;
_300:
  I := I + 1;
  JJ := I;
  while ( JJ<=N ) do
   begin
    Z[JJ-1] := MulC(T,Z[JJ-1]);
    Z[JJ+0] := MulC(T,Z[JJ+0]);
    Z[JJ+1] := MulC(T,Z[JJ+1]);
    Z[JJ+2] := MulC(T,Z[JJ+2]);
    Z[JJ+3] := MulC(T,Z[JJ+3]);
_310:
    inc(JJ,5);
   end;
_320:
  if ( LL=330 ) then goto _330 else
  if ( LL=480 ) then goto _480 else
  if ( LL=530 ) then goto _530 else
  if ( LL=570 ) then goto _570 else
  if ( LL=620 ) then goto _620 else
  if ( LL=660 ) then goto _660 else
  if ( LL=670 ) then goto _670 else
  if ( LL=750 ) then goto _750;
_330:
  EK := MulC(T,EK);
_340:
  WK := SubC(EK,Z[K-1]);
  WKM :=SubC(SubC(Cmplx(0.0,0.0),EK),Z[K-1]);
  S := C1ABS(WK);
  SM := C1ABS(WKM);
  if ( Cabs(A[(K-1)+(K-1)*M]) =  0.0 ) 
   then goto _350;
  WK := DivC(WK,A[(K-1)+(K-1)*M]);
  WKM := DivC(WKM,A[(K-1)+(K-1)*M]);
  goto _360;
_350:
  WK := Cmplx(1.0,0.0);
  WKM := Cmplx(1.0,0.0);
_360:
  KP1 := K + 1;
  if ( KP1 >  N ) 
   then goto _400;
  for J:=KP1 to N do
   begin
    SM := SM + C1ABS(AddC(Z[J-1],MulC(WKM,Conjg(A[(K-1)+(J-1)*M]))));
    Z[J-1] := AddC(Z[J-1],MulC(WK,Conjg(A[(K-1)+(J-1)*M])));
    S := S + C1ABS(Z[J-1]);
_370:
   end;
  if ( S >=  SM ) 
   then goto _390;
  T := SubC(WKM,WK);
  WK := WKM;
  for J:=KP1 to N do
   begin
    Z[J-1] := AddC(Z[J-1],MulC(T,Conjg(A[(K-1)+(J-1)*M])));
_380:
   end;
_390:
_400:
  Z[K-1] := WK;
_410:
 end;
LL := 470;
_420:
S := 0.0;
I := ((N) Mod (6));
if ( I =  0 ) 
 then goto _440;
for JJ:=1 to I do
 begin
  S := S + C1ABS(Z[JJ-1]);
_430:
 end;
if ( N <  6 ) 
 then goto _460;
_440:
I := I + 1;
JJ := I;
while ( JJ<=N ) do
 begin
  S := S + C1ABS(Z[JJ-1]) + C1ABS(Z[JJ+0]) + C1ABS(Z[JJ+1])
    + C1ABS(Z[JJ+2]) + C1ABS(Z[JJ+3]) + C1ABS(Z[JJ+4]);
_450:
  inc(JJ,6);
 end;
_460:
S := 1.0/S;
if ( LL=470 ) then goto _470 else
if ( LL=560 ) then goto _560 else
if ( LL=650 ) then goto _650 else
if ( LL=740 ) then goto _740;
_470:
LL := 480;
goto _280;
_480:

{   PEEHE CCTEM TRANS(L)*Y=W }
for KB:=1 to N do
 begin
  K := N + 1 - KB;
  if ( K >=  N ) 
   then goto _520;
  KP1 := K + 1;
  JJ := N - K;
  I := ((JJ) Mod (5)) + K;
  if ( I =  K ) 
   then goto _500;
  for JJ:=KP1 to I do
   begin
    Z[K-1] := AddC(Z[K-1],MulC(Conjg(A[(JJ-1)+(K-1)*M]),Z[JJ-1]));
_490:
   end;
_500:
  I := I + 1;
  if ( I >  N ) 
   then goto _520;
  JJ := I;
  while ( JJ<=N ) do
   begin
    Z[K-1] := AddC(AddC(AddC(AddC(AddC(Z[K-1],MulC(Conjg(A[(JJ-1)+(K-1)*M]),Z[JJ-1])),MulC(Conjg(
    A[(JJ+0)+(K-1)*M]),Z[JJ+0])),MulC(Conjg(A[(JJ+1)+(K-1)*M]),
    Z[JJ+1])),MulC(Conjg(A[(JJ+2)+(K-1)*M]),Z[JJ+2])),
    MulC(Conjg(A[(JJ+3)+(K-1)*M]),Z[JJ+3]));
_510:
    inc(JJ,5);
   end;
_520:
  if ( C1ABS(Z[K-1]) <=  1.0 ) 
   then goto _540;
  S := 1.0/C1ABS(Z[K-1]);
  LL := 530;
  goto _280;
_530:
_540:
  L := NLEAD[K-1];
  T := Z[L-1];
  Z[L-1] := Z[K-1];
  Z[K-1] := T;
_550:
 end;
LL := 560;
goto _420;
_560:
LL := 570;
goto _280;
_570:
YNORM := 1.0;

{   PEEHE CCTEM L*V=Y  BCEHE HOPM BEKTOPA Y }
for K:=1 to N do
 begin
  L := NLEAD[K-1];
  T := Z[L-1];
  Z[L-1] := Z[K-1];
  Z[K-1] := T;
  if ( K >=  N ) 
   then goto _610;
  KP1 := K + 1;
  JJ := N - K;
  I := ((JJ) Mod (4)) + K;
  if ( I =  K ) 
   then goto _590;
  for JJ:=KP1 to I do
   begin
    Z[JJ-1] := AddC(Z[JJ-1],MulC(T,A[(JJ-1)+(K-1)*M]));
_580:
   end;
_590:
  I := I + 1;
  if ( I >  N ) 
   then goto _610;
  JJ := I;
  while ( JJ<=N ) do
   begin
    Z[JJ-1] := AddC(Z[JJ-1],MulC(T,A[(JJ-1)+(K-1)*M]));
    Z[JJ+0] := AddC(Z[JJ+0],MulC(T,A[(JJ+0)+(K-1)*M]));
    Z[JJ+1] := AddC(Z[JJ+1],MulC(T,A[(JJ+1)+(K-1)*M]));
    Z[JJ+2] := AddC(Z[JJ+2],MulC(T,A[(JJ+2)+(K-1)*M]));
_600:
    inc(JJ,4);
   end;
_610:
  if ( C1ABS(Z[K-1]) <=  1.0 ) 
   then goto _630;
  S := 1.0/C1ABS(Z[K-1]);
  LL := 620;
  goto _280;
_620:
  YNORM := S*YNORM;
_630:
_640:
 end;
LL := 650;
goto _420;
_650:
LL := 660;
goto _280;
_660:
YNORM := S*YNORM;

{   PEEHE CCTEM U*Z=V }
for KB:=1 to N do
 begin
  K := N + 1 - KB;
  if ( C1ABS(Z[K-1]) <=  C1ABS(A[(K-1)+(K-1)*M]) ) 
   then goto _680;
  S := C1ABS(A[(K-1)+(K-1)*M])/C1ABS(Z[K-1]);
  LL := 670;
  goto _280;
_670:
  YNORM := S*YNORM;
_680:
  if ( Cabs(A[(K-1)+(K-1)*M]) <>  0.0 ) 
   then Z[K-1] := DivC(Z[K-1],A[(K-1)+(K-1)*M]);
  if ( Cabs(A[(K-1)+(K-1)*M]) =  0.0 ) 
   then Z[K-1] := Cmplx(1.0,0.0);
  T := SubC(Cmplx(0.0,0.0),Z[K-1]);
  L := K - 1;
  if ( L <  1 ) 
   then goto _720;
  I := ((L) Mod (4));
  if ( I =  0 ) 
   then goto _700;
  for JJ:=1 to I do
   begin
    Z[JJ-1] := AddC(Z[JJ-1],MulC(T,A[(JJ-1)+(K-1)*M]));
_690:
   end;
_700:
  I := I + 1;
  if ( I >  L ) 
   then goto _720;
  JJ := I;
  while ( JJ<=L ) do
   begin
    Z[JJ-1] := AddC(Z[JJ-1],MulC(T,A[(JJ-1)+(K-1)*M]));
    Z[JJ+0] := AddC(Z[JJ+0],MulC(T,A[(JJ+0)+(K-1)*M]));
    Z[JJ+1] := AddC(Z[JJ+1],MulC(T,A[(JJ+1)+(K-1)*M]));
    Z[JJ+2] := AddC(Z[JJ+2],MulC(T,A[(JJ+2)+(K-1)*M]));
_710:
    inc(JJ,4);
   end;
_720:
_730:
 end;
LL := 740;
goto _420;
_740:
LL := 750;
goto _280;
_750:
YNORM := S*YNORM;
if ( ANORM <>  0.0 ) 
 then RCOND := YNORM/ANORM;
_760:
end;

end.
